=== debian/changelog ===
audacity (2.4.2~dfsg0-5) unstable; urgency=medium

  * Workaround patch for playback cursor under wayland
    Audacity has no full wayland support yet, so we use X11 to start
    (Closes: #950150, #962389, #988632, LP: #1877833)
    The patch can probably be removed when wxwidgets 3.1.3 is in debian archive
  * Add lintian-overrides to override false positive lintian errors

 -- Dennis Braun <d_braun@kabelmail.de>  Wed, 26 May 2021 22:26:01 +0200

audacity (2.4.2~dfsg0-4) unstable; urgency=medium

  [ Sebastian Ramacher ]
  * Bump cmake requirement (Closes: #969571)

  [ Dennis Braun ]
  * Fix temporary audio .au files exposure (CVE-2020-11867). (Closes: #976874)
  * Bump S-V to 4.5.1, no changes needed

 -- Dennis Braun <d_braun@kabelmail.de>  Tue, 08 Dec 2020 23:46:09 +0100

audacity (2.4.2~dfsg0-3) unstable; urgency=medium

  * Team upload
  * debian/rules: Properly link ffmpeg libraries

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 24 Jul 2020 00:27:55 +0200

audacity (2.4.2~dfsg0-2) unstable; urgency=medium

  * Team upload
  * debian/rules: Disable use of embedded sbsms

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 23 Jul 2020 22:26:16 +0200

audacity (2.4.2~dfsg0-1) unstable; urgency=medium

  * Team upload

  [ Dennis Braun ]
  * New upstream version 2.4.1~dfsg0
  * Exclude unfree RFC files and unnecessary autogenerated files
  * Fix wrong use of AC_CHECK_FILE for portmidi (Closes: #960093)
  * Refresh d/copyright
  * d/audacity.mime: Remove quotes from %s placeholder
  * d/rules: Remove obsolete linker flags

  [ Sebastian Ramacher ]
  * New upstream release
  * debian/: Build with cmake
    - Update build dependencies
    - Move arch dependent plugins to /usr/lib/audacity
    - Remove autoconf/automake patches
    - Apply patches to use system libraries
  * debian/copyright: Remove copyright info for autconf/automake files

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 23 Jul 2020 20:48:30 +0200

audacity (2.3.3-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #850463)
   + cross.patch: Fix wrong use of AC_CHECK_FILE

  [ Dennis Braun ]
  * d/audacity.install: Add /usr/share/metainfo
  * d/audacity.lintian-overrides: Drop, obsolete
  * d/control:
    + Bump Standards-Version to 4.5.0
    + Bump dh-compat to 13
    + Add me as an uploader
    + Set RRR: no
  * d/copyright:
    + Remove a lot of unused entries
    + Get rid of CC-BY with no version, use CC-BY-3.0 instead,
      like LICENSE.txt says
    + Add CC0-1.0 license for appdata
  * Add d/not-installed
  * Add d/upstream/metadata

 -- Dennis Braun <d_braun@kabelmail.de>  Sat, 02 May 2020 02:53:01 +0200
